## ros-crystal-rviz-ogre-vendor 5.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rviz_ogre_vendor)

find_package(ament_cmake REQUIRED)

set(PACKAGE_VERSION "1.0.0")

if(WIN32)
  set(BUILDING_FREETYPE_LOCALLY ON)
  set(BUILDING_ZLIB_LOCALLY ON)
else()
  set(BUILDING_FREETYPE_LOCALLY OFF)
  set(BUILDING_ZLIB_LOCALLY OFF)
endif()

if(WIN32 AND NOT ${CMAKE_VERBOSE_MAKEFILE})
  set(should_log ON)  # prevent warnings in Windows CI
else()
  set(should_log OFF)
endif()

macro(build_freetype)
  set(extra_cmake_args)

  if(WIN32)
    list(APPEND extra_cmake_args "-DCMAKE_CXX_FLAGS=/w")
    list(APPEND extra_cmake_args "-DCMAKE_C_FLAGS=/w")
  endif()

  include(ExternalProject)
  ExternalProject_Add(freetype-2.8.1
    URL https://git.savannah.gnu.org/cgit/freetype/freetype2.git/snapshot/freetype2-VER-2-6-5.tar.gz
    URL_MD5 0dd62a0125895431e074a3df29f94d69
    TIMEOUT 600
    LOG_CONFIGURE ${should_log}
    LOG_BUILD ${should_log}
    CMAKE_ARGS
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/freetype_install
      ${extra_cmake_args}
      -Wno-dev
      -DWITH_ZLIB=OFF
      -DWITH_BZip2=OFF
      -DWITH_PNG=OFF
      -DWITH_HarfBuzz=OFF
  )

  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/freetype_install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}/opt/rviz_ogre_vendor
  )
endmacro()

macro(build_zlib)
  set(extra_cmake_args)

  if(WIN32)
    list(APPEND extra_cmake_args "-DCMAKE_CXX_FLAGS=/w")
    list(APPEND extra_cmake_args "-DCMAKE_C_FLAGS=/w")
  endif()

  include(ExternalProject)
  ExternalProject_Add(zlib-1.2.11
    URL https://www.zlib.net/fossils/zlib-1.2.11.tar.gz
    URL_MD5 1c9f62f0778697a09d36121ead88e08e
    TIMEOUT 600
    LOG_CONFIGURE ${should_log}
    LOG_BUILD ${should_log}
    CMAKE_ARGS
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/zlib-install
      ${extra_cmake_args}
      -Wno-dev
  )

  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/zlib-install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}/opt/rviz_ogre_vendor
  )
endmacro()

macro(build_ogre)
  set(extra_cmake_args)
  if(DEFINED CMAKE_BUILD_TYPE)
    list(APPEND extra_cmake_args -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})
  endif()
  if(WIN32)
    list(APPEND extra_cmake_args "-DCMAKE_CXX_FLAGS=/w /EHsc")
    list(APPEND extra_cmake_args "-DCMAKE_C_FLAGS=/w /EHsc")
  elseif(APPLE)
    list(APPEND extra_cmake_args "-DCMAKE_CXX_FLAGS=-std=c++14 -stdlib=libc++ -w")
    list(APPEND extra_cmake_args "-DCMAKE_OSX_ARCHITECTURES='x86_64'")
  else()
    list(APPEND extra_cmake_args "-DCMAKE_CXX_FLAGS=-std=c++14 -w")
    list(APPEND extra_cmake_args "-DCMAKE_C_FLAGS=-w")
  endif()
  list(APPEND extra_cmake_args "-DOGRE_BUILD_RENDERSYSTEM_GL:BOOL=TRUE")
  list(APPEND extra_cmake_args "-DOGRE_BUILD_RENDERSYSTEM_D3D11:BOOL=OFF")
  list(APPEND extra_cmake_args "-DOGRE_BUILD_RENDERSYSTEM_D3D9:BOOL=OFF")

  # Uncomment this line to enable the GL3PLUS render engine
  # list(APPEND extra_cmake_args "-DOGRE_BUILD_RENDERSYSTEM_GL3PLUS:BOOL=TRUE")

  # These next lines can be used to disable some of the components or plugins for OGRE
  # list(APPEND extra_cmake_args "-DOGRE_BUILD_COMPONENT_BITES:BOOL=OFF")
  # list(APPEND extra_cmake_args "-DOGRE_BUILD_COMPONENT_HLMS:BOOL=ON")
  list(APPEND extra_cmake_args "-DOGRE_CONFIG_ENABLE_ZIP:BOOL=ON")

  if(BUILDING_FREETYPE_LOCALLY)
    list(APPEND extra_cmake_args
      "-DFREETYPE_HOME=${CMAKE_CURRENT_BINARY_DIR}/freetype_install")
  endif()
  if(BUILDING_ZLIB_LOCALLY)
    list(APPEND extra_cmake_args
      "-DZLIB_ROOT=${CMAKE_CURRENT_BINARY_DIR}/zlib_install")
  endif()

  if(WIN32)
    set(patch_exe patch.exe)
  else()
    set(patch_exe patch)
  endif()

  include(ExternalProject)
  ExternalProject_Add(ogre-master-ca665a6
    URL https://github.com/OGRECave/ogre/archive/v1.10.11.zip
    URL_MD5 6ffd5048fae72805e287bfc0b462b2ea
    TIMEOUT 1200
    LOG_CONFIGURE ${should_log}
    LOG_BUILD ${should_log}
    CMAKE_ARGS
      -DOGRE_STATIC:BOOL=OFF
      -DOGRE_DEPENDENCIES_DIR=${CMAKE_CURRENT_BINARY_DIR}/ogredeps
      -DOGRE_INSTALL_PDB:BOOL=OFF
      -DOGRE_BUILD_DEPENDENCIES:BOOL=OFF
      -DOGRE_BUILD_TESTS:BOOL=OFF
      -DOGRE_BUILD_SAMPLES:BOOL=FALSE
      -DOGRE_INSTALL_SAMPLES:BOOL=FALSE
      -DOGRE_INSTALL_SAMPLES_SOURCE:BOOL=FALSE
      -DOGRE_CONFIG_THREADS:STRING=0
      -DOGRE_RESOURCEMANAGER_STRICT:BOOL=ON
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/ogre_install
      -DOGRE_BUILD_LIBS_AS_FRAMEWORKS:BOOL=OFF
      ${extra_cmake_args}
      -Wno-dev
    PATCH_COMMAND
      ${patch_exe} -p1 -N < ${CMAKE_CURRENT_SOURCE_DIR}/ogre-ca665a6-patch.diff
  )

  if(BUILDING_FREETYPE_LOCALLY)
    add_dependencies(ogre-master-ca665a6 freetype-2.8.1)
  endif()
  if(BUILDING_ZLIB_LOCALLY)
    add_dependencies(ogre-master-ca665a6 zlib-1.2.11)
  endif()

  # The external project will install to the build folder, but we'll install that on make install.
  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/ogre_install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}/opt/rviz_ogre_vendor
  )
endmacro()

if(BUILDING_FREETYPE_LOCALLY)
  build_freetype()
endif()
if(BUILDING_ZLIB_LOCALLY)
  build_zlib()
endif()

build_ogre()

if(WIN32)
  ament_environment_hooks(env_hook/rviz_ogre_vendor_library_path.bat)
else()
  ament_environment_hooks(env_hook/rviz_ogre_vendor_library_path.sh)
endif()

ament_package(
  CONFIG_EXTRAS "rviz_ogre_vendor-extras.cmake.in"
)

=== debian/changelog ===
ros-crystal-rviz-ogre-vendor (5.1.1-1bionic) bionic; urgency=high

  * Constraint Freetype dependencies for more predictable build result on Windows. (#393 <https://github.com/ros2/rviz/issues/393>)
  * Contributors: Sean Yen

 -- William Woodall <william@osrfoundation.org>  Fri, 06 Dec 2019 08:00:00 -0000

ros-crystal-rviz-ogre-vendor (5.1.0-1bionic) bionic; urgency=high

  * Skip the system directories when looking for OGRE (#371 <https://github.com/ros2/rviz/issues/371>)
  * Contributors: Scott K Logan

 -- William Woodall <william@osrfoundation.org>  Mon, 14 Jan 2019 08:00:00 -0000

ros-crystal-rviz-ogre-vendor (5.0.0-1bionic) bionic; urgency=high

  * Changed ZLIB_ROOT -> ZLIB_DIR (#349 <https://github.com/ros2/rviz/issues/349>)
  * Contributors: Mikael Arguedas

 -- William Woodall <william@osrfoundation.org>  Tue, 04 Dec 2018 08:00:00 -0000

ros-crystal-rviz-ogre-vendor (4.0.1-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Thu, 28 Jun 2018 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (4.0.0-1bionic) bionic; urgency=high

  * Changed the download timeout for Ogre to be twenty (20) minutes. (#323 <https://github.com/ros2/rviz/issues/323>)
  * Contributors: Dirk Thomas, Martin Idel, Mikael Arguedas, Russ

 -- William Woodall <william@osrfoundation.org>  Wed, 27 Jun 2018 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (3.0.0-1bionic) bionic; urgency=high

  * Updated Ogre to 1.10.11. (#181 <https://github.com/ros2/rviz/issues/181>)

 -- William Woodall <william@osrfoundation.org>  Wed, 07 Feb 2018 08:00:00 -0000

ros-crystal-rviz-ogre-vendor (2.0.0-1bionic) bionic; urgency=high

  * First version for ROS 2.
  * Contributors: Andreas Greimel, Andreas Holzner, Chris Ye, Johannes Jeising, Martin Idel, Steven! Ragnarok, William Woodall

 -- William Woodall <william@osrfoundation.org>  Fri, 08 Dec 2017 08:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.11-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 02 Aug 2017 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.10-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 06 Jun 2017 00:37:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.9-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 05 Jun 2017 21:23:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.8-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Sun, 07 May 2017 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.7-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Fri, 05 May 2017 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.6-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 02 May 2017 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.5-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 01 May 2017 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.4-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Thu, 27 Oct 2016 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.3-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 19 Oct 2016 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.2-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 18 Oct 2016 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.1-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 20 Apr 2016 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.12.0-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 11 Apr 2016 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.14-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Sun, 03 Apr 2016 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.13-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 23 Mar 2016 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.12-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 23 Mar 2016 02:58:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.11-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 23 Mar 2016 01:16:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.10-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 13 Oct 2015 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.9-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 21 Sep 2015 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.8-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 05 Aug 2015 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.7-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 02 Mar 2015 08:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.6-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Fri, 13 Feb 2015 08:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.5-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 11 Feb 2015 08:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.4-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Thu, 30 Oct 2014 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.3-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Thu, 26 Jun 2014 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.2-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 13 May 2014 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.1-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Thu, 01 May 2014 07:00:00 -0000

ros-crystal-rviz-ogre-vendor (1.11.0-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 05 Mar 2014 05:40:00 -0000



=== debian/control ===
Source: ros-crystal-rviz-ogre-vendor
Section: misc
Priority: optional
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), libfreetype6-dev, libgl1-mesa-dev, libglu1-mesa-dev, libx11-dev, libxaw7-dev, libxrandr-dev, pkg-config, ros-crystal-ament-cmake, ros-crystal-ros-workspace
Homepage: https://www.ogre3d.org/
Standards-Version: 3.9.2

Package: ros-crystal-rviz-ogre-vendor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfreetype6, libfreetype6-dev, libgl1-mesa-dev, libglu1-mesa-dev, libx11-dev, libxaw7-dev, libxrandr-dev, ros-crystal-ros-workspace
Description: Wrapper around ogre3d, it provides a fixed CMake module and an ExternalProject build of ogre.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/crystal/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/crystal" \
		-DAMENT_PREFIX_PATH="/opt/ros/crystal"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-crystal-rviz-ogre-vendor//opt/ros/crystal/lib/:$(CURDIR)/debian/ros-crystal-rviz-ogre-vendor//opt/ros/crystal/opt/rviz_ogre_vendor/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_install
